/*
 * scanner.h
 *
 * Created: 2014-04-04 14:37:30
 *  Author: dsosnowski
 */ 


#ifndef SCANNER_H_
#define SCANNER_H_

#define SCAN_BUFF_SIZE		64
#define SCAN_MAX_CELL		16
#define SCAN_BUFF_MIN		8
#define SCAN_PULSE_MIN		5
#define SCAN_PULSE_MAX		250
#define SCAN_PULSE_TOLERANCE		4

//---------------------------------------
#define SCAN_IDLE			0
#define SCAN_FIND			1
#define SCAN_START			2
#define SCAN_PROCESS		3
#define SCAN_COMPLETE		4
#define SCAN_ERROR			5




#define PRESCALER_RESET		GTCCR |= (1<<PSRSYNC)
#define TIMER_START			TCCR0B = (1<<CS02)
//div 256, 80000000/256 = 0,000 032s per tick
//cycle = 0,0082 s

//div 256, 11059200/256 = 0,000 023s per tick
//cycle = 0,0059 s
			
//#define TIMER_START			TCCR0 = (1<<CS01 | 1<<CS00)
//div 64, 11059200/256 = 0,000 00579s per tick
//cycle = 0,0015 s

#define TIMER_STOP			TCCR0B  = 0
#define TIMER_RESET			TCNT0   = 0
#define TIMER_ENABLE		TIMSK0 |= (1<<TOIE0)
#define TIMER_DISABLE		TIMSK0 &=~(1<<TOIE0)
#define TIMER_CLEAR			TIFR0  |= (1<<TOV0)
#define TIMER_VALUE			TCNT0


//config interrupts
#define INT0_CONFIG			EICRA |= (1<<ISC00)			//any level
#define INT0_ENABLE			EIMSK |= (1<<INT0)
#define INT0_DISABLE		EIMSK &=~(1<<INT0)
#define INT0_CLEAR			EIFR  |= (1<<INTF0)


void ScannerInit (void);
char ScannerStatus(void);
void ScannerStart (void);
void ScannerStop(void);
void ScannerSave(char cell);
void ScannerLoad(char cell);
char ScannerComp(void);
void EEwrite(unsigned int address, char data);
char EEread(unsigned int address);

#endif /* SCANNER_H_ */